/*
 * Copyright (C) 2004-2013 L2J DataPack
 * 
 * This file is part of L2J DataPack.
 * 
 * L2J DataPack is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * L2J DataPack is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package ai.individual;

import static com.l2jserver.gameserver.datatables.SkillTable.*;
import ai.npc.AbstractNpcAI;

import com.l2jserver.gameserver.datatables.SpawnTable;
import com.l2jserver.gameserver.model.L2Spawn;
import com.l2jserver.gameserver.model.actor.L2Npc;
import com.l2jserver.gameserver.model.actor.instance.L2PcInstance;
import com.l2jserver.gameserver.model.skills.L2Skill;

/**
 * Sprigant AI.
 * @author St3eT
 */
public final class Sprigant extends AbstractNpcAI
{
	// NPC
	private static final int ANESTHESIA_SPRIGNANT = 18345;	// アラクノイド
	private static final int DEADLY_SPRIGNANT = 18346;		// アラクノイド
	
	// Skills
	private static int ANESTHESIA = getSkillHashCode(5085, 1);		// 麻酔 - 麻酔にかかり瞬時に動けなくなった状態。targetType=AURA
	private static int DEADLY_POISON = getSkillHashCode(5086, 1);	// 致命的な毒 - 毒にかかり瞬時にHPが減少した状態。HPを0になると死亡します。targetType=AURA
	
	private Sprigant()
	{
		super(Sprigant.class.getSimpleName(), "ai/individual");
		addSpawnId(ANESTHESIA_SPRIGNANT, DEADLY_SPRIGNANT);
		
if (!com.l2jserver.Config.FIX_onSpawn_for_SpawnTable) {{
		for (L2Spawn spawn : SpawnTable.getInstance().getSpawns(ANESTHESIA_SPRIGNANT))
		{
			onSpawn(spawn.getLastSpawn());
		}
		
		for (L2Spawn spawn : SpawnTable.getInstance().getSpawns(DEADLY_SPRIGNANT))
		{
			onSpawn(spawn.getLastSpawn());
		}
}}
	}
	
	@Override
	public String onAdvEvent(String event, L2Npc npc, L2PcInstance player)
	{
		if (event == "useSkill")
		{
			if (npc.isDead() || !npc.isVisible())
			{
				cancelQuestTimer(event, npc, player);
			}
			else if (npc.getKnownList().getKnownPlayers().size() > 0)
			{
				L2Skill skill = getSkill(npc.getId() == ANESTHESIA_SPRIGNANT ? ANESTHESIA : DEADLY_POISON);
				npc.doCast(skill);
			}
		}
		return super.onAdvEvent(event, npc, player);
	}
	
	@Override
	public String onSpawn(L2Npc npc)
	{
		L2Skill skill = getSkill(npc.getId() == ANESTHESIA_SPRIGNANT ? ANESTHESIA : DEADLY_POISON);
		startQuestTimer("useSkill", 15000 + skill.getHitTime() + skill.getCoolTime(), npc, null, true);
		return super.onSpawn(npc);
	}
	
	public static void main(String[] args)
	{
		new Sprigant();
	}
}